<template>
  <section class="room-map">
    <div class="room-map__top-row">
      <h4 class="room-map__title">
        Расположение
      </h4>

      <div class="room-map__arrow"
           v-if="isMobile"
           @click="$emit('mobileToTop')"
      >
        <icon-small-arrow />
      </div>
    </div>

    <!--<p class="room-map__description">-->
      <!--Центральный вход, со стороны улицы Гончарной. На входе необходимо предъявить паспорт.-->
    <!--</p>-->

    <div class="room-map__map">
      <client-only>

      <yandex-map :coords="coords" :controls="controls">
        <ymap-marker
          marker-id="1"
          :coords="coords"
          :icon="markerIcon"
        />
      </yandex-map>

      </client-only>
    </div>
  </section>
</template>

<script>
  import IconSmallArrow from './icons/IconSmallArrow';

  export default {
    name: 'RoomMap',
    props: {
      coords: {
        type: Array,
        required: true
      },
      address: {
        type: String,
        required: true
      }
    },
    components: {
      IconSmallArrow
    },
    data: () => ({
      mapCenter: [55.741950, 37.649909],
      markerCenter: [55.741950, 37.649909],
      markerIcon: {
        layout: 'default#imageWithContent',
        imageHref: '/images/icon-map-pin.svg',
        imageSize: [50, 62],
        imageOffset: [-25, -62],
        content: '',
        contentOffset: [55, 11],
        contentLayout: '<div class="room-map__pin-label">$[properties.iconContent]</div>'
      },
      controls: [ 'geolocationControl', 'zoomControl' ]
    }),
    mounted() {
      this.markerIcon.content = this.address;
    },
    watch: {
      address() {
        this.markerIcon.content = this.address;
      }
    },
    computed: {
      isMobile() {
        return this.$store.state.isMobile;
      }
    },
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .room-map {
    &__top-row {
      display: flex;
      align-items: center;
      justify-content: space-between;
      margin-bottom: rem(32);
    }

    &__arrow {
      @include to-top-arrow;
    }

    &__title {
      @include h4;
    }

    &__description {
      @include p2;

      margin-bottom: rem(40);
      line-height: rem(22);
    }

    &__map {
      padding: rem(6);
      height: rem(430);

      background: $white;
      box-shadow: inset rem(-4) rem(-4) rem(2) rgba($white, 0.6),
      inset rem(4) rem(4) rem(6) #D5DCE4,
      inset rem(-4) rem(-4) rem(4) rgba($white, 0.25);
      border-radius: rem(8);

      .ymap-container {
        height: 100%;
      }
    }

    &__pin-label {
      display: block;
      padding: rem(4) rem(8);
      width: max-content;

      white-space: nowrap;
      color: $black;
      font-weight: 600;

      background: rgba($white, .75);
      border-radius: rem(4);
    }
  }
</style>
